﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WriteErase.Pages
{
    /// <summary>
    /// Логика взаимодействия для Auth.xaml
    /// </summary>
    public partial class Auth : Page
    {
        public TradeEntities DB = new TradeEntities();
        bool CapaFlag = false;
        System.Windows.Threading.DispatcherTimer timer = new System.Windows.Threading.DispatcherTimer();
        string Capcha = "";
        public Auth()
        {
            InitializeComponent();
        }

        private void GoAuth(object sender, RoutedEventArgs e)
        {
            if (Login.Text != null && Login.Text != "" && Password.Password != null && Password.Password != "")
            {
                User user = DB.User.Where(x => x.UserLogin == Login.Text && x.UserPassword == Password.Password).FirstOrDefault();
                if (user != null && CapaFlag == false)
                {
                    MainClass.mFrame.Navigate(new Guest(user.UserID));
                }
                else if (user != null && CapaFlag == true)
                {
                    if (CapaText.Text.ToUpper() == Capcha.ToUpper())
                    {
                        MainClass.mFrame.Navigate(new Guest(user.UserID));
                    }
                    else
                    {
                        MessageBox.Show("Каптча введена правильно");
                        AuthUser.IsEnabled = false;
                        AuthGuest.IsEnabled = false;
                        timer.Tick += new EventHandler(timerTick);
                        timer.Interval = new TimeSpan(0, 0, 10);
                        timer.Start();

                    }
                }
                else if (user == null && CapaFlag == true)
                {
                    MessageBox.Show("Такого аккаунта не существует, либо данные введены не верно");
                    AuthUser.IsEnabled = false;
                    AuthGuest.IsEnabled = false;
                    timer.Tick += new EventHandler(timerTick);
                    timer.Interval = new TimeSpan(0, 0, 10);
                    timer.Start();
                }
                else
                {
                    MessageBox.Show("Такого аккаунта не существует, либо данные введены не верно");
                    Capa.Visibility = Visibility.Visible;
                    CreateCap();
                    CapaFlag = true;
                }
            }
            else
            {
                MessageBox.Show("Все поля должны быть заполнены");
            }
        }

        private void GoGuest(object sender, RoutedEventArgs e)
        {
            MainClass.mFrame.Navigate(new Guest());
        }

        private void timerTick(object sender, EventArgs e)
        {
            AuthUser.IsEnabled = true;
            AuthGuest.IsEnabled = true;
        }

        public void CreateCap()
        {
            Capcha = "";
            SolidColorBrush color = new SolidColorBrush(Colors.Red);
            Canvas canava = new Canvas()
            {
                Width = 200,
                Height = 100,
                Background = color,
                Margin = new Thickness(0, 10, 0, 0)
            };
            Random r = new Random();
            int fs;
            FontStyle fontStyle = FontStyles.Normal;
            FontWeight fontWeight = FontWeights.Normal;
            for (int i = 1; i <= 6; i++)
            {
                fs = r.Next(1, 3);
                if (fs == 1)
                {
                    fontStyle = FontStyles.Oblique;
                }
                if (fs == 2)
                {
                    fontWeight = FontWeights.Bold;
                }
                if (fs == 3)
                {
                    fontWeight = FontWeights.Bold;
                    fontStyle = FontStyles.Italic;
                }
                TextBlock tb = new TextBlock()
                {
                    Padding = new Thickness(i * 19, r.Next(100), 0, r.Next(50)),
                    Foreground = new SolidColorBrush(Colors.DarkRed),
                    FontStyle = fontStyle,
                    FontWeight = fontWeight
                };
                if (i % 2 == 0)
                {
                    tb.Text = Convert.ToString((char)r.Next(65, 90));
                }
                else
                {
                    tb.Text = Convert.ToString(r.Next(1, 7));
                }
                Capcha += tb.Text;
                canava.Children.Add(tb);
                Line line = new Line()
                {
                    X1 = r.Next(200),
                    Y1 = r.Next(100),
                    X2 = r.Next(200),
                    Y2 = r.Next(100),
                    Stroke = Brushes.Blue,
                    StrokeThickness = 1
                };
                canava.Children.Add(line);
            }

            CapchaPic.Children.Add(canava);
        }
    }
}
